﻿//===============================================================================================================
// System  : Sandcastle Help File Builder WPF Controls
// File    : NamedStyle.cs
// Author  : Eric Woodruff  (Eric@EWoodruff.us)
// Updated : 01/12/2013
// Note    : Copyright 2012-2013, Eric Woodruff, All rights reserved
// Compiler: Microsoft Visual C#
//
// This file contains the class used to contain the named styles used in the converted flow document
//
// This code is published under the Microsoft Public License (Ms-PL).  A copy of the license should be
// distributed with the code.  It can also be found at the project website: http://SHFB.CodePlex.com.  This
// notice, the author's name, and all copyright notices must remain intact in all applications, documentation,
// and source files.
//
// Version     Date     Who  Comments
// ==============================================================================================================
// 1.9.3.4  01/02/2012  EFW  Created the code
//===============================================================================================================

namespace SandcastleBuilder.WPF.Maml
{
    /// <summary>
    /// These define the named styles used in the converted flow document
    /// </summary>
    public static class NamedStyle
    {
        /// <summary>Alert body style</summary>
        public const string AlertBody = "AlertBody";
        /// <summary>Alert title style</summary>
        public const string AlertTitle = "AlertTitle";
        /// <summary>Code block style</summary>
        public const string CodeBlock = "CodeBlock";
        /// <summary>Code inline style</summary>
        public const string CodeInline = "CodeInline";
        /// <summary>Defined term style</summary>
        public const string DefinedTerm = "DefinedTerm";
        /// <summary>Definition style</summary>
        public const string Definition = "Definition";
        /// <summary>Glossary definition style</summary>
        public const string GlossaryDefinition = "GlossaryDefinition";
        /// <summary>Glossary division title style</summary>
        public const string GlossaryDivisionTitle = "GlossaryDivisionTitle";
        /// <summary>Glossary letter bar style</summary>
        public const string GlossaryLetterBar = "GlossaryLetterBar";
        /// <summary>Glossary letter title style</summary>
        public const string GlossaryLetterTitle = "GlossaryLetterTitle";
        /// <summary>Literal style</summary>
        public const string Literal = "Literal";
        /// <summary>Math style</summary>
        public const string Math = "Math";
        /// <summary>No margin paragraph style</summary>
        public const string NoMargin = "NoMargin";
        /// <summary>No top margin paragraph style</summary>
        public const string NoTopMargin = "NoTopMargin";
        /// <summary>Quote paragraph style</summary>
        public const string Quote = "Quote";
        /// <summary>Related topic title style</summary>
        public const string RelatedTopicTitle = "RelatedTopicTitle";
        /// <summary>Table header row style</summary>
        public const string TableHeaderRow = "TableHeaderRow";
        /// <summary>Table title style</summary>
        public const string TableTitle = "TableTitle";
        /// <summary>Title style</summary>
        public const string Title = "Title";
    }
}
